#include <Servo.h>
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"

SoftwareSerial mySerial(3, 2); // RX, TX

DFRobotDFPlayerMini myMP3;
// create servo objects
Servo faceMotors;
Servo handMotors1;
Servo handMotors2;

// set ultrasonic sensor pins
int trigPin = 11;
int echoPin = 12;

// set pins for servo motors and tap sensor
int faceMotorsPin = 10;
int handMotors1Pin = 9;
int handMotors2Pin = 8;
int tapSensorPin = 7;

// variables to hold servo positions
int faceMotorsPos = 0;
int handMotorsPos1 = 0;
int handMotorsPos2 = 0;



void setup() {

  mySerial.begin(9600);
  myMP3.begin(mySerial);
  myMP3.volume(30);
  // attach servo objects to pins
  faceMotors.attach(faceMotorsPin);
  handMotors1.attach(handMotors1Pin);
  handMotors2.attach(handMotors2Pin);

  // set initial servo positions to 0 degrees
  faceMotors.write(0);
  handMotors1.write(0);
  handMotors2.write(0);

  // set tap sensor pin as input
  pinMode(tapSensorPin, INPUT);

  // set ultrasonic sensor pins
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);


}

void loop() {
  // check if tap sensor has been tapped
if (digitalRead(tapSensorPin) == HIGH) {
       myMP3.play(2);
    //rotate face motors 7 times in 3 seconds
    for (int i = 0; i < 6; i++) {
      faceMotorsPos = 30;
      faceMotors.write(faceMotorsPos);
      delay(250);
      faceMotorsPos = 0;
      faceMotors.write(faceMotorsPos);
      delay(250);
    }
//rotate hand motors to 90 degrees in opposite directions
handMotorsPos1 = 90;
handMotorsPos2 = 0;
handMotors1.write(handMotorsPos1);
handMotors2.write(handMotorsPos2);
delay(1000);

//rotate hand motors back to 0 degrees in opposite directions
handMotorsPos1 = 0;
handMotorsPos2 = 90;
handMotors1.write(handMotorsPos1);
handMotors2.write(handMotorsPos2);
delay(500);
}
if (digitalRead(tapSensorPin) == LOW){
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // receive and calculate ultrasonic signal
  long duration, distance;
  duration = pulseIn(echoPin, HIGH);
  Serial.println(duration);
  distance = duration * 0.034 / 2;// send ultrasonic signal
  Serial.println(distance);
  if(distance > 0 && distance < 5){// print distance to serial monitor
    myMP3.play(1);
    for (int i = 0; i < 17; i++) {
      faceMotorsPos = 30;
      faceMotors.write(faceMotorsPos);
      delay(250);
      faceMotorsPos = 0;
      faceMotors.write(faceMotorsPos);
      delay(250);
    }
  }
 }
 }
